unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, dbf, FileUtil, Forms, Controls, Graphics, Dialogs,
  DBGrids, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    CheckBox1: TCheckBox;
    DataSource1: TDataSource;
    Dbf1: TDbf;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    Label1: TLabel;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    function CountRecords(ADataset: TDataset): Integer;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  dbf1.Locate('PLZ', Edit1.Text, [loCaseInsensitive, loPartialKey]);
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  if Checkbox1.Checked then begin
    dbf1.Filter := 'PLZ = "' + Edit1.Text + '*"';
    dbf1.Filtered := true;
    Label1.Caption := IntToStr(CountRecords(dbf1)) + ' records';
  end else
    dbf1.Filtered := false;
end;

function TForm1.CountRecords(ADataset: TDataset): Integer;
var
  bm: TBookmark;
begin
  Result := 0;
  ADataset.DisableControls;
  bm := ADataset.GetBookmark;
  try
    ADataset.First;
    while not ADataset.EoF do begin
      inc(Result);
      ADataset.Next;
    end;
    ADataset.GotoBookmark(bm);
  finally
    ADataset.FreeBookmark(bm);
    ADataset.EnableControls;
  end;
end;


procedure TForm1.Edit1Change(Sender: TObject);
begin
  Checkbox1.Checked := false;
  dbf1.Filtered := false;
  dbf1.Locate('PLZ', Edit1.Text, [loCaseInsensitive, loPartialKey]);
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  TableName : String = 'Test';
begin
  dbf1.FilePath := '';
  dbf1.TableName := TABLENAME + '.dbf';

  if not FileExists(dbf1.FilePathFull + dbf1.TableName) then
  begin
    with dbf1.FieldDefs do begin
      Add('Name', ftString, 20, true);
      Add('Vorname', ftString, 20);
      Add('Ort', ftString, 20);
      Add('PLZ', ftString, 5);
    end;
    dbf1.createTable;
    dbf1.Close;

    dbf1.Exclusive := True;
    dbf1.Open;
    dbf1.AddIndex('name_idx', 'Name', [ixPrimary, ixCaseInsensitive]);
    dbf1.Close;

    dbf1.Open;
    dbf1.Open;
    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'ABC';
    dbf1.FieldByName('Vorname').AsString := 'abc';
    dbf1.FieldByName('Ort').AsString := 'abc';
    dbf1.FieldByName('PLZ').AsString := '12345';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'ABZ';
    dbf1.FieldByName('Vorname').AsString := 'abz';
    dbf1.FieldByName('Ort').AsString := 'abz';
    dbf1.FieldByName('PLZ').AsString := '12345';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'DEF';
    dbf1.FieldByName('Vorname').AsString := 'def';
    dbf1.FieldByName('Ort').AsString := 'def';
    dbf1.FieldByName('PLZ').AsString := '23456';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'GHI';
    dbf1.FieldByName('Vorname').AsString := 'ghi';
    dbf1.FieldByName('Ort').AsString := 'ghi';
    dbf1.FieldByName('PLZ').AsString := '23456';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'JKL';
    dbf1.FieldByName('Vorname').AsString := 'jkl';
    dbf1.FieldByName('Ort').AsString := 'jkl';
    dbf1.FieldByName('PLZ').AsString := '23456';
    dbf1.Post;

    dbf1.Append;
    dbf1.FieldByName('Name').AsString := 'MNO';
    dbf1.FieldByName('Vorname').AsString := 'mno';
    dbf1.FieldByName('Ort').AsString := 'mno';
    dbf1.FieldByName('PLZ').AsString := '34567';
    dbf1.Post;
  end;

  dbf1.Open;
end;

end.

